/*#######################################################################################

AVR Embedded Webservice Project

File        : debug.h

Description : Implements external debug-functions and specifies several levels (header).

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#ifndef _DEBUG_H
#define _DEBUG_H


// Diese Zeile immer anpassen, damit zwei Leute die aufm gleichen ATmega
// debuggen sehen, wer ihn gerade resettet hat!
// Im aktuellen Makefile kann sich jeder ein Target bauen, das die Zeile
// enth?lt. F?r Stefan, Andreas und Jon gibt es solche Targets
// #define DEBUG_USER      "unknown"

	
// Hier kann jeder seine Debugeinstellungen setzen!
#define DEBUG_JON 1
#define DEBUG_AND 2
#define DEBUG_STF 3

#if DEBUG_USER==DEBUG_JON 
	//Debugmeldungen ein/auschalten
	#define DEBUG_USER_NAME "Jon"
	#define IP1             192
	#define IP2             168
/*	#ifndef IP3
		#define IP3             123
	#endif*/
	#define IP4             198
	#define DEBUG_MEM       1
	#define DEBUG_VERBOSE   0
	#define DEBUG_MAIN      0
	#define DEBUG_CALLS     0
	#define DEBUG_CLOCK     0
	#define DEBUG_NIC       0
	#define DEBUG_ETHERNET  0
	#define DEBUG_ARP       0
	#define DEBUG_ARP_GET   0
	#define DEBUG_ARP_SEND  0
	#define DEBUG_ARP_CACHE 0
	#define DEBUG_IP        0
	#define DEBUG_ICMP      0
	#define DEBUG_TCP       0
	#define DEBUG_UDP       0
	#define DEBUG_DHCP      1
	
#elif DEBUG_USER==DEBUG_AND
	#define DEBUG_USER_NAME "Andreas"
	#define IP4             198
	#define DEBUG_MEM       0
	#define DEBUG_VERBOSE   0
	#define DEBUG_MAIN      0
	#define DEBUG_CALLS     0
	#define DEBUG_CLOCK     0
	#define DEBUG_NIC       0
	#define DEBUG_ETHERNET  0
	#define DEBUG_ARP       0
	#define DEBUG_ARP_GET   0
	#define DEBUG_ARP_SEND  0
	#define DEBUG_ARP_CACHE 0
	#define DEBUG_IP        0	
	#define DEBUG_ICMP      0
	#define DEBUG_TCP       0
	#define DEBUG_UDP       0
	#define DEBUG_DHCP      1
	
#elif DEBUG_USER==DEBUG_STF
	#define DEBUG_USER_NAME "Stefan"
	#define IP1             192
	#define IP2             168
	#define IP3             123
	#define IP4             199
	#define DEBUG_MEM       1
	#define DEBUG_VERBOSE   0
	#define DEBUG_MAIN      0
	#define DEBUG_CALLS     0
	#define DEBUG_CLOCK     0
	#define DEBUG_NIC       0
	#define DEBUG_ETHERNET  0
	#define DEBUG_ARP       0
	#define DEBUG_ARP_GET   0
	#define DEBUG_ARP_SEND  0
	#define DEBUG_ARP_CACHE 0
	#define DEBUG_IP        0
	#define DEBUG_ICMP      0
	#define DEBUG_TCP       0
	#define DEBUG_UDP       0
	#define DEBUG_DHCP      1
	
#else
	#define DEBUG_USER_NAME "unknown"
	#define IP1             192
	#define IP2             168
	#define IP3             2
	#define IP4             198
	#define DEBUG_VERBOSE   0
	#define DEBUG_MEM       1
	#define DEBUG_VERBOSE   0
	#define DEBUG_MAIN      0
	#define DEBUG_CALLS     0
	#define DEBUG_CLOCK     0
	#define DEBUG_NIC       0
	#define DEBUG_ETHERNET  0
	#define DEBUG_ARP       0
	#define DEBUG_ARP_GET   0
	#define DEBUG_ARP_SEND  0
	#define DEBUG_ARP_CACHE 0
	#define DEBUG_IP        0
	#define DEBUG_ICMP      0
	#define DEBUG_TCP       0
	#define DEBUG_UDP       0
	#define DEBUG_DHCP      1
#endif


extern void debug_print(unsigned char *debug_msg, unsigned char *debug_line, 
	unsigned char debug_length);

// #define _DEBUG_H
#endif

