/*#######################################################################################

AVR Embedded Webservice Project

File        : ethernet.h

Description : Reading and sending between high-/low-level protocols (header).

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de
based on code from Ulrich Radig for the AVR Small Webserver 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#ifndef _ETHERNET_H
#define _ETHERNET_H

#define ETHER_HEADER_OFFSET 0x00
#define ETHER_HEADER_SIZE   14
#define ETHER_MIN_SIZE      64-4
#define ETHER_TRAILER_SIZE  4

typedef char MAC_ADDRESS[6];

extern MAC_ADDRESS mac_broadcast_addr;

char NIC_INT;
char InterruptCounter ;

// Prototyp der receive() Funktion
int Ethernet_Receive (void);
void Ethernet_Send (unsigned char *Packet_Dest, unsigned char Packet_Type[2], unsigned char *Packet_Data, unsigned int Packet_Length);

struct Ethernet_Header	{
	unsigned char EnetPacketDest[6];	//MAC Zieladresse 6 Byte
	unsigned char EnetPacketSrc[6];		//MAC Quelladresse 6 Byte
	unsigned char EnetPacketType[2];	//Nutzlast 0x0800=IP Datagramm;0x0806 = ARP
};

// #define _ETHERNET_H
#endif

