/*#######################################################################################

AVR Embedded Webservice Project

File        : httpd.c

Description : Implementation of the HTTP protocol.

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#include "main.h"
#include <webpage.h>


//############################################################################
//
void httpd_receive (TCP_CONN_ID c, char* buffer,int *bufferlen)
//############################################################################
{	
 unsigned int tcpdata;
//Errechnet startpunkt der Daten im Tcp buffer
//IP Headerlnge + TCP Headerlnge + Ethernetframe
// tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
	tcpdata = 0;

	//Verwaltung Stackpointer

	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack (buffer,bufferlen,&a)==1)
		{
		return;//keine Daten fuer Anwendung
		}

	tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
	
	//berprueft HTTP Header 
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1)		{
		unsigned char Header = 1;
			
		//Pointerold auf INDEX.HTM
		pointerold = WSDL_fail;
		Header = 1;
		// STEFAN: length of abs_path+query is limited to 9+2*"\0"
		// because our webservice only needs so much characters
		unsigned char abs_path[GET_MAXABSPATHLEN+1];
		unsigned char query[GET_MAXQUERYLEN+1];
		char *tmppointer2 = HTTP_OK1;
		//berprueft Header nach "GET /File_Name HTTP....."
		if ( memcmp(&buffer[tcpdata],"GET /",5) == 0){
			char *tmppointer = &buffer[tcpdata + 5];
			unsigned char counter = 0;
			//Der Header wird durchsucht beginnend bei GET /
			//bis zum nchsten Space Zeichen
			while (* tmppointer != '?' && counter<GET_MAXABSPATHLEN){
			    abs_path[counter++] = *tmppointer++;
			}
			abs_path[counter]='\0';
			counter = 0;			
			*tmppointer++;
			while (* tmppointer != 0x20 && counter<GET_MAXQUERYLEN){
				query[counter] = *tmppointer++;
				counter++;
			}
			query[counter] = '\0';
			// Successfully parsed HTTP Packet, now call WSDLHandler
			if(WSDLHandler(&abs_path,&query)==0){
			    tmppointer2 = HTTP_OK1;
			    pointerold = WSDL_success;			    
			} else {pointerold = WSDL_fail;tmppointer2 = HTTP_OK2;}
		}
		
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);	
	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;
		//erzeugt HTTP OK Packet
		tcp_add_data (tmppointer2,buffer,bufferlen);	
		//Erzeugt ein TCP Packet 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);
		//(Ethernet Farne war aber voll) Weiters Frame mu gesendet werden!
		tcp_socket->Status = TCP_SOCKET_OPEN2;
//		tcp_socket->Status = TCP_SOCKET_CLOSE;
		tcp_socket->Pointer = pointerold;
		return;
		}
	
	//Senden der Webseite bzw. Daten war noch nicht Fertig (Ethernet Farne war aber voll)	
	if (tcp_socket->Status == TCP_SOCKET_OPEN2) 
		{
			unsigned char Buffer_Full = 0;
			//Setzen des Ack Flags und PSH Flags	
			buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//erzeugt Seiten Packet
			
			#if USE_MMC
				if(tcp_socket->Cluster != 0)
					{
					Read_File (tcp_socket->Cluster,&buffer[tcpdata],tcp_socket->File_Block_Counter);
					tcp_socket->File_Block_Counter++;
					if (tcp_socket->File_Size > (unsigned long)512)
						{
						Buffer_Full = 1; //es wurden noch nicht alle Daten gesendet
						(unsigned long) tcp_socket->File_Size = (unsigned long) tcp_socket->File_Size - 512;
						TCP_New_Packtlen (buffer,bufferlen,tcpdata + 512);
						}
						else
						{
						Buffer_Full = 0; //es wurden alle Daten gesendet
						TCP_New_Packtlen (buffer,bufferlen,tcpdata + tcp_socket->File_Size);
						}
					goto endmakepacket;
					}
			#endif //USE_MMC
		
			pointerold = tcp_socket->Pointer;
			Buffer_Full = tcp_add_data (pointerold,buffer,bufferlen);
			tcp_socket->Pointer = pointerold;
			
			endmakepacket:
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);	
			if (Buffer_Full == 0)
				{
				#if USE_MMC
				tcp_socket->Cluster = 0;
				#endif //USE_MMC
				tcp_socket->Status = TCP_SOCKET_CLOSE;
				}
			return;		
		}
return;
}


