	#include "main.h"

// MAC Adresse der Karte
//const unsigned char mymac[] = {0,32,24,177,14,178}; // Jons Karte
const unsigned char mymac[] = {0,32,24,177,6,49}; // Andreas Karte


//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{

	UART_Init();
	printf ("<debug>");
	#ifdef DEBUG_USER
		printf ("compiled by: %s\n", DEBUG_USER_NAME);
	#endif
	
	init_mem();
	//Grundinizialisierung der Netzwerkkarte
	Init_Realtek_Network_Card();

	// Debug LEDs
	// Programm running LED
	#if DEBUG_USER==DEBUG_JON 	
		if (ReadRTL(0)==34) ledon(1);
	#endif
	// Timer LED
	ledoff(2);

	#if DEBUG_MAIN
		printf ("Card Init: %d \n", ReadRTL(0));
		//Ausgabe meiner MAC Adresse auf Serieller Schnittstelle
		printf("My Mac: %02x:%02x:%02x:%02x:%02x:%02x", mymac[0], mymac[1], mymac[2],
														mymac[3], mymac[4], mymac[5]);
		debug_print(" -", (unsigned char *)mymac, 6);
		//Ausgabe meiner IP Adresse auf Serieller Schnittstelle
		printf("My IP : %03d.%03d.%03d.%03d", 
			ipconfig->ipAddress[0],
			ipconfig->ipAddress[1],
			ipconfig->ipAddress[2],
			ipconfig->ipAddress[3]);
			
		debug_print("   -", (unsigned char *)ipconfig->ipAddress, 4);

	#endif
	
	#if DEBUG_MAIN
		print("Start Clock: ... ");
	#endif

	#if USE_CLOCK
		Start_Clock();
	#endif
		
	#if DEBUG_MAIN
		print("done.\n");
	#endif

	#if DEBUG_MAIN
		print("Globale Interrupts: ... ");
	#endif
		
	//Globale Interrupts Einschalten
	sei ();
	
	#if DEBUG_MAIN
		printf("an.\n");
	#endif

	#if DEBUG_MAIN
		print("Interrupt 0 loest aus bei: ... ");
	#endif
	//Interrupt 4 Mega103/128 Interrupt 0 bei Mega32 
	//soll ausloesen bei ansteigender Flanke
	Networkcard_INT_Set();
	#if DEBUG_MAIN
		print("ansteigender Flanke.\n");
	#endif
	
	#if DEBUG_MAIN
		print("Interrupt 0: ... ");
	#endif
	//Interrupt 4 oder 0 Einschalten (fuer die Netzwerkkarte)
	Networkcard_INT_Enable();
	#if DEBUG_MAIN
		print("an.\n");
	#endif
	
//	</debug> has to be added manually to the debug output

return (1);
}

