/*#######################################################################################

AVR Embedded Webservice Project

File        : main.h

Description : Well... this is the header to main.c ;-)

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#ifndef _MAIN_H
#define _MAIN_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <ctype.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/eeprom.h>


#define print(x)  printf(x)

#include "clock.h"
#include "debug.h"
#include "ethernet.h"
#include "rtl8019.h"
#include "uart.h"
#include "arp.h"
#include "ip.h"
#include "tcp.h"
#include "mem.h"
#include "udp.h"
#include "dhcp.h"
#include "led.h"
#include "tcp.h"
#include "ports.h"
#include "testapp.h"
#include "wsdl.h"
#include "webpage.h"



extern const unsigned char mymac[];
extern const unsigned char MYIP[];

//MTU Size setzen (min. 500 / max. 1400)
//#### jetzt in MEM.H #### #define MTU_SIZE  800

/* Der Quarz auf dem Experimentierboard hat eine Frequenz von 14.318MHz
Quarz Frequenz in Hz */
#define SYSCLK	16000000

#if defined (__AVR_ATmega32__)	
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT0);
#endif	

#if defined (__AVR_ATmega32__)	
	#define Networkcard_INT_Set()	MCUCR=0x01;
#endif	

#define INT2CHAR2(intvar,charvar) charvar[0]=(intvar>>8)&0xFF; charvar[1]=intvar&0xFF

#define CHAR2LONG(c) ((((unsigned long)(c)[0]<<24)&0xFF000000)+(((unsigned long)(c)[1]<<16)&0x00FF0000)+(((unsigned long)(c)[2]<<8)&0x0000FF00)+(((unsigned long)(c)[3])&0x000000FF))
#define CHAR2INT(c) ((((unsigned int)(c)[0]<<8)&0xFF00)+(((unsigned int)(c)[1])&0x00FF))

#endif
// _MAIN_H






