/*#######################################################################################

AVR Embedded Webservice Project

File        : mem.c

Description : Global declarations of memory regions.

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#include "mem.h"
#include "ip.h"
#include "tcp.h"
#include "ports.h"

//T_IPCONFIG *ipconfig;
//ipconfig = (T_IPCONFIG*)(&((char*)reservedMemory[MEM_IP_CONFIG_OFFSET]));

struct DHCP_Config dhcp_config;
struct UDP_SOCKET udp_sockets[UDP_MAX_SOCKETS];
struct IPCONFIG* ipconfig;

//############################################################################
void init_mem(){
//############################################################################
	
	#if DEBUG_MEM
		printf("\nReserved Memory: %i Bytes\n", RESERVED_MEMORY);
		printf("IP Configuration: %i Bytes\n", 
				sizeof(ipconfig_mem));
		printf("TCP Sockets: %i Bytes\n", 
				TCP_MAX_SOCKETS*sizeof(tcp_sockets));
		printf("TCP Connections: %i Bytes\n", 
				TCP_MAX_CONNECTIONS*sizeof(tcp_connections));
		printf("TCP Retransmission Buffer: %i Bytes\n", 
				TCP_MAX_CONNECTIONS*sizeof(TCP_Retransmission_Buffer));
		printf("ARP Cache: %i Bytes\n",sizeof(arp_cache));
		printf("UDP Sockets: %i Bytes\n",sizeof(udp_sockets));
		printf("DHCP Configuration: %i Bytes\n",sizeof(dhcp_config));
	#endif	


	// ### I P ################################################
//	ipconfig = (struct IPCONFIG *)&reservedMemory[MEM_IP_CONFIG_OFFSET];
	ipconfig = (struct IPCONFIG *)&ipconfig_mem;
	// = {{192,168,123,198},{255,255,255,0},{192,168,123,1}};
	ipconfig->ipAddress[0]=192;
	ipconfig->ipAddress[1]=168;
	ipconfig->ipAddress[2]=123;
	ipconfig->ipAddress[3]=199;
	ipconfig->netMask[0]=255;
	ipconfig->netMask[1]=255;
	ipconfig->netMask[2]=255;
	ipconfig->netMask[3]=0;
	ipconfig->gateway[0]=192;
	ipconfig->gateway[1]=168;
	ipconfig->gateway[2]=2;
	ipconfig->gateway[3]=254;

	#ifdef IP1
		ipconfig->ipAddress[0]=IP1;
	#endif
	#ifdef IP2
		ipconfig->ipAddress[1]=IP2;
	#endif
	#ifdef IP3
		ipconfig->ipAddress[2]=IP3;
	#endif
	#ifdef IP4
		ipconfig->ipAddress[3]=IP4;
	#endif
	
	// ### U D P #############################################
//	udp_sockets = (struct UDP_SOCKET*)&reservedMemory[MEM_UDP_SOCKETS_OFFSET];
	dhcp_config.dhcp_state=0;

	// ### T C P #############################################
	// map memory for Sockets and Connections
//	tcp_sockets = (struct TCP_SOCKET*)&reservedMemory[MEM_TCP_SOCKETS_OFFSET];
//	tcp_connections = (struct TCB*)&reservedMemory[MEM_TCP_CONN_OFFSET];
	// create listening connection on HTTP Port
	tcp_connections[0].status = TCP_STAT_LISTEN;
	tcp_connections[0].localSocket=0;
	tcp_sockets[tcp_connections[0].localSocket].ipAddr[0] = ipconfig->ipAddress[0];
	tcp_sockets[tcp_connections[0].localSocket].ipAddr[1] = ipconfig->ipAddress[1];
	tcp_sockets[tcp_connections[0].localSocket].ipAddr[2] = ipconfig->ipAddress[2];
	tcp_sockets[tcp_connections[0].localSocket].ipAddr[3] = ipconfig->ipAddress[3];
	tcp_sockets[tcp_connections[0].localSocket].port = TCP_PORT_HTTP;
	
	
}


