/*#######################################################################################

AVR Embedded Webservice Project

File        : testapp.c

Description : Test-application to demonstrate webservice.

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#include "main.h"

//############################################################################
int switchChannel(int channel, int value){
//############################################################################
    outp(0xff,DDRB);
    switch(channel){
	case 0: channel=1;break;
    	case 1: channel=2;break;
	case 2: channel=4;break;
	case 3: channel=8;break;
	case 4: channel=16;break;
	case 5: channel=32;break;
    	case 6: channel=64;break;
	case 7: channel=128;break;
    }
    if(value==1) outp(channel | PORTB,PORTB);
    else if(value==0) outp((255-channel) & PORTB,PORTB);
    else if(value==2){
    	outp(channel | PORTB,PORTB);
    	long i;
    	for (i=0;i<100000000;i++);
    	outp((255-channel) & PORTB,PORTB);
    	for (i=0;i<100000000;i++);
    	outp(channel | PORTB,PORTB);
    	for (i=0;i<100000000;i++);
    	outp((255-channel) & PORTB,PORTB);
    	for (i=0;i<100000000;i++);
    	outp(channel | PORTB,PORTB);
    	for (i=0;i<100000000;i++);
    	outp((255-channel) & PORTB,PORTB);
    }
    return 0;
}




//############################################################################
signed char testapp_receive(char tcpconn, unsigned char* buffer, int bufferlen){
//############################################################################
	
	if (bufferlen==0) return 0;
//	cli();

//	debug_print("Testapp is reading: ",buffer, bufferlen);
//	TCP_Send(tcpconn, "HTTP/1.0 200 Document follows\r\n", 33, 0, 0, 0);


	unsigned char abs_path[GET_MAXABSPATHLEN+1];
	unsigned char query[GET_MAXQUERYLEN+1];
	char *tmppointer2 = HTTP_OK1;
	char *pagepointer;
	char show_description=0;

	//Check HTTP Header for "GET /File_Name HTTP....."
	//TODO: possibly wait for more fragments of the call
	if ( memcmp(&buffer[0],"GET /",5) == 0){
		//search Header for space or ? beginning at "GET /"
		unsigned char counter = 0;
		char *tmppointer = &(buffer[5]);
		while (
			   (*tmppointer != '?')
			&& (*tmppointer != 0x20)
			&& (counter<GET_MAXABSPATHLEN)
		){
		    abs_path[counter++] = *tmppointer++;
		}
		// if filename == "" lets send out webservice description
		if (counter==0) show_description=1;
		else if (abs_path[0]=='B') show_description=2;
		#if DEBUG_APP
			printf("GET Parser, counter: %i\n",counter);
		#endif
		// Parsing path and dropping filename	y
		abs_path[counter]='\0';
		counter = 0;			
		*tmppointer++;
		while (*tmppointer != 0x20 && counter<GET_MAXQUERYLEN){
			query[counter] = *tmppointer++;
			counter++;
		}
		query[counter] = '\0';
		// Successfully parsed HTTP Packet, now call WSDLHandler
		if(WSDLHandler((char*) &abs_path,(char*) &query)==0){
		    tmppointer2 = (char*)HTTP_OK1;
		    pagepointer = WSDL_user;			    
		} else if (show_description==1){
			tmppointer2 = HTTP_OK2;
			pagepointer = WSDL_fail;
		} else if (show_description==2){
			tmppointer2 = HTTP_OK1;
			pagepointer = WSDL_user;
		} else {
			tmppointer2 = HTTP_NOTFOUND;
			pagepointer = NULL;
		}
	} else {
		return 0;	
	}

	// Send HTTP Status
	int newlen=0;
	while(strncmp_P("END",(tmppointer2+1),3)!=0)
	{
		buffer[newlen++] = pgm_read_byte_near(tmppointer2++);
		#if DEBUG_APP && DEBUG_VERBOSE
			printf("%02x",buffer[newlen]);
		#endif
		//sind die daten lnger als ein Ethernetbuffer dann abbruch
		if (newlen >  (TCP_PAYLOAD_SIZE - 1)){
			TCP_Send(tcpconn, buffer, newlen, 0, 0, 0);
			newlen = 0;
		}

	}
	if (newlen>0)
		TCP_Send(tcpconn, buffer, newlen, 1, 0, 0);
//	cli();

	// Send Webpage
	if (pagepointer != NULL) {
		// Send Content
		#if DEBUG_APP
			print("Reading Page from ROM: ");
		#endif
		tmppointer2 = pagepointer;
		newlen=0;
		while(strncmp_P("END",(tmppointer2+1),3)!=0)
		{
			buffer[newlen++] = pgm_read_byte_near(tmppointer2++);
			#if DEBUG_APP && DEBUG_VERBOSE
				printf("%02x",buffer[newlen]);
			#endif
			//sind die daten lnger als ein Ethernetbuffer dann abbruch
			if (newlen >  (TCP_PAYLOAD_SIZE - 1)){
				TCP_Send(tcpconn, buffer, newlen, 0, 0, 0);
				newlen = 0;
			}
	
		}
	//	printf("Lnge des WSDEL Dingsbums: %i\n",newlen);
		if (newlen>0)
			TCP_Send(tcpconn, buffer, newlen, 1, 0, 0);
	//	cli();
	}
	
	TCP_Close(tcpconn);

//	sei();
//	printf("FERTIG: %i\n",newlen);
	
	return 1;	
}
