/*#######################################################################################

AVR Embedded Webservice Project

File        : uart.c

Description : Print to serial console.

Copyright notice:

Copyright (C) 2004 - Ulrich Radig (originally written for AVR Small Webserver).

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#include "main.h"
#include "uart.h"

//############################################################################
//Routine fuer die Serielle Ausgabe
int uart_putchar (char c)
//############################################################################
{
	//Nur wichtig fuer Windows_Terminals? Auf Unix doppelte LF's
	if (c == '\n')
			uart_putchar('\r');

	//Warten solange bis Zeichen gesendet wurde
	loop_until_bit_is_set(USR, UDRE);
	//Ausgabe des Zeichens
	UDR = c;
	return (0);
}

//############################################################################
//INstallation der Seriellen Schnittstelle
void UART_Init (void)
//############################################################################
{
	//Enable TXEN im Register UCR TX-Data Enable
	UCR=(1 << TXEN);
	//Teiler wird gesetzt 
	UBRR=(SYSCLK / (BAUD_RATE * 16L) - 1);
	
	//ffnet einen Kanal fuer printf (STDOUT)
	fdevopen (uart_putchar, NULL, 0);
}

