/*#######################################################################################

AVR Embedded Webservice Project

File        : uart.h

Description : Print to serial console (header).

Copyright notice:

Copyright (C) 2004 - Ulrich Radig (originally written for AVR Small Webserver).

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#ifndef _UART_H
 #define _UART_H

extern void UART_Init (void);
extern int uart_putchar (char c);

//Die Baud_Rate der Seriellen Schnittstelle ist 9600 Baud
#define BAUD_RATE 9600		//Baud Rate fuer die Serielle Schnittstelle	
//#define BAUD_RATE 14400		//Baud Rate fuer die Serielle Schnittstelle	
//#define BAUD_RATE 28800		//Baud Rate fuer die Serielle Schnittstelle	
//#define BAUD_RATE 57600		//Baud Rate fuer die Serielle Schnittstelle	

//Anpassen der seriellen Schnittstellen Register wenn ein ATMega128 benutzt wird
#if defined (__AVR_ATmega128__)
#	define USR UCSR0A
#	define UCR UCSR0B
#	define UDR UDR0
#	define UBRR UBRR0L
#	define EICR EICRB
#endif

#if defined (__AVR_ATmega32__)
#	define USR UCSRA
#	define UCR UCSRB
#	define UBRR UBRRL
#	define EICR EICRB
#endif

#endif //_UART_H
