/*#######################################################################################

AVR Embedded Webservice Project

File        : udp.h

Description : Implementation of the UDP protocol (header).

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#ifndef _UDP_H_
#define _UDP_H_

#define UDP_HEADER_SIZE 8
#define UDP_PROTOCOL 0x11
#define UDP_MAX_SOCKETS 2

struct UDP_SOCKET{
	unsigned char port[2];
	IP_ADDRESS ip;
};

typedef struct UDP_HEADER{
	unsigned char sourcePort[2];  // optional
	unsigned char destPort[2];    // type of servive
	unsigned char length[2];
	unsigned char checksum[2];
} T_UDPHEADER;

extern signed char UDP_Send(struct UDP_SOCKET* destSocket,struct UDP_SOCKET* sourceSocket,unsigned char* packet,int packetlen);
extern signed char UDP_Receive( IP_ADDRESS* destAddr,IP_ADDRESS* sourceAddr,unsigned char* packet,int packetlen);
extern struct UDP_SOCKET udp_sockets[];
#endif //_UDP_H_
