/*#######################################################################################

AVR Embedded Webservice Project

File        : webpage.c

Description : Writes data for the webpage into EEPROM.

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#include "main.h"
#include "webpage.h"

PROGMEM char HTTP_OK1[] = {
"HTTP/1.0 200 Document follows\r\n"
"Server: AVR_Small_Webserver\r\n" 
//"Connection: Keep-Alive\r\n" 
"Content-Type: text/html\r\n"
"\r\n"
"%END"
};

PROGMEM char HTTP_NOTFOUND[] = {
"HTTP/1.0 404 NOT FOUND\r\n"
"Server: AVR_Small_Webserver\r\n" 
//"Connection: Keep-Alive\r\n" 
"Content-Type: text/html\r\n"
"\r\n"
"%END"
};

PROGMEM char HTTP_OK2[] = {
"HTTP/1.0 200 Document follows\r\n"
"Server: AVR_Small_Webserver\r\n" 
//"Connection: Keep-Alive\r\n" 
"Content-Type: text/xml\r\n"
"\r\n"
"%END"
};

PROGMEM char WSDL_success[]={
"success!\r\n"
"\r\n"
"%END"
};


PROGMEM char WSDL_user[]={
"<html>"
"<style>"
" body,form,button,select{font-family:verdana,arial,helvetica,sans-serif;font-size:9pt;color:000066;}"
"</style>"
"<body>"
"<h2>Embedded Webservice</h2>"
"Hier kann nun schick der PORT B des Webservice geschaltet werden:"
"<form method=get action=A>"
"Pin: <select name=d>"
" <option value=0>0</option>"
" <option value=1>1</option>"
" <option value=2>2</option>"
" <option value=3>3</option>"
" <option value=4>4</option>"
" <option value=5>5</option>"
" <option value=6>6</option>"
" <option value=7>7</option>"
"</select>"
"<button name=v value=1>an</button><button name=v value=0>aus</button><button name=v value=2>blink</button>"
"</form>"
"</body>"
"</html>"
"%END"
};

PROGMEM char WSDL_fail[]={
"<?xml version=\"1.0\"?>\r\n"
"<description name=\"AVR_WebPlug\" targetNamespace=\"http://ourUDDI/AVR_WebPlub.wsdl\">\r\n"
"	<message name=\"f1\">\r\n"
"		<part name=\"d\" type=\"xsd:int\" />\r\n"
"		<part name=\"v\" type=\"xsd:boolean\" />\r\n"
"	</message>\r\n"
"	<message name=\"rf1\">\r\n"
"		<part name=\"respone\" type=\"xsd:string\" />\r\n"
"	</message>\r\n"
"	<portType name=\"steckdose\">\r\n"
"		<operation name=\"A\">\r\n"
"		    	<input message=\"f1\" />\r\n"
"			<output message=\"rf1\" />\r\n"
"		</operation>\r\n"
"	</portType>\r\n"
"	<service name=\"webplug\">\r\n"
"		<port name=\"steckdose\" binding=\"binding1\">\r\n"
"		    <http:address location=\"http://192.168.0.199/\" />\r\n"
"		</port>\r\n"
"	</service>\r\n"
"	<binding name=\"binding1\" type=\"steckdose\">\r\n" 
"		<http:binding verb=\"GET\" />\r\n"
"		<operation name=\"f1\">\r\n"
"			<http:operation location=\"A\" />\r\n"
"		<input><http:urlEncoded /></input>\r\n"
"		<output>\r\n"
"			<mime:content type=\"text\\html\" />\r\n"
"		</output>\r\n"
"		</operation>\r\n"
"	</binding>\r\n"		
"</description>\r\n"
"%END"
};
