/*#######################################################################################

AVR Embedded Webservice Project

File        : wsdl.c

Description : Implementation of the WSDL protocol.

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Chris Helbing, helbing@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de
Stefan Wanja, wanja@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#######################################################################################*/


#include "main.h"
#include <string.h>

//############################################################################
int parseGETRequest(char* abs_path, char* query, int* types[], char* params, char* function){
//############################################################################
    // GET http://blablabla/abhierzaehlts?param1=value1&paramx=valuex HTTP/1.1
    // GET / HTTP/1.1   
    // extract function name
    if(strlen(abs_path)==1){
	*function=abs_path[0];
    } else {return 1;}
    // extract parameters for functions
    switch(function[0]){
	case 'A': {	
		    // check for correct format //
		    if(query[0]!='d') return 1;
		    if(query[1]!='=') return 1;
		    if(!isdigit(query[2])) return 1;
		    if(query[3]!='&') return 1;
		    if(query[4]!='v') return 1;
		    if(query[5]!='=') return 1;
//		    if(query[6]!='0' | query[6]!='1') return 1;
		    if(!isdigit(query[6])) return 1;
		    // check for correct values //
		    // skipped //
		    // declare of which datatype the params are
		    *types[0]=WSDL_TYPE_INT;
		    *types[1]=WSDL_TYPE_INT;
		    params[0]=query[2];
		    params[1]=query[6];
		    return 0;
		   }
	
	default: return 1;break;
    }
    
    return 1;    
}

//############################################################################
int ctoi(char c){
//############################################################################
    switch(c){
	case '0': return 0;
	case '1': return 1;
	case '2': return 2;
	case '3': return 3;
	case '4': return 4;
	case '5': return 5;
	case '6': return 6;
	case '7': return 7;
	case '8': return 8;
	case '9': return 9;
	default: return -1;
    }
}

/*int ctob(char c){
    if(c=='1') return 1; else return 0;
}*/

//############################################################################
int WSDLHandler(char * abs_path, char* query){
//############################################################################
    char params[5];
    char types[5];
    char function;
     if(parseGETRequest(abs_path, query, &types, &params, &function)!=0) {
//	DEBUG(LAYER_WSDL,"Invalid Request");
	return 1;
    }
    //ruft die Funktionen mit entsprechenden Parametern
    if(strcmp(function,"S")==0){
    // Funktion SetState
		#if DEBUG_APP
			printf("DUMMYFUNCTION SetState");
		#endif
    }
    if(strcmp(function,"G")==0){
    // Funktion GetState
    }
    if(function=='A'){
    
	#if DEBUG_APP
		printf("Funktion A wurde mit den Parametern %d, %d aufgerufen\n",ctoi(params[0]),ctoi(params[1]));
	#endif
	
	extern int switchChannel(int channel, int value);
	if(switchChannel(ctoi(params[0]),ctoi(params[1]))==0)
	    {
			#if DEBUG_APP
		    	printf("Webservice executed succesfully");
		    #endif
	    } else {
			#if DEBUG_APP
		    	printf("Error while executing webservice");
		    #endif
	    	return -1;
	    }
    }
    return 0;
}
